/*
 * @Author: smallStone
 * @Date: 2018-07-03 12:19:49
 * @Last Modified by: smallStone
 * @Last Modified time: 2018-07-20 16:14:03
 * webview 相关
 */
var webview = {
    identifier: 'com.lanhu.sketch',
    threadDictionary: NSThread.mainThread().threadDictionary(),
    /**
     * 注册函数
     * @param {any} context
     * @param {any} isAll
     * @param {any} callback
     * @returns
     */
    render: function (context, isAll, callback) {
        var result = false,
            width = 540,
            height = 430,
            _this = this,
            bgcolor = NSColor.colorWithRed_green_blue_alpha(1, 1, 1, 1),
            identifier = this.identifier,
            lanhuSketch = this.threadDictionary[identifier];
        if (lanhuSketch) {

            return
        }
        url = rootUrl + '/sketch' + '?time=' + Math.random() * 100;
        coscript.setShouldKeepAround(true);

        var webViewPanel = NSPanel.alloc().init();
        webViewPanel.setTitleVisibility(NSWindowTitleHidden);
        webViewPanel.setTitlebarAppearsTransparent(true);
        webViewPanel.standardWindowButton(NSWindowCloseButton).setHidden(false);
        webViewPanel.standardWindowButton(NSWindowMiniaturizeButton).setHidden(true);
        webViewPanel.standardWindowButton(NSWindowZoomButton).setHidden(true);
        webViewPanel.setFrame_display(NSMakeRect(0, 32, width, height), false);
        webViewPanel.setBackgroundColor(bgcolor);

        var contentView = webViewPanel.contentView(),
            webView = WebView.alloc().initWithFrame(NSMakeRect(0, 0, width, height)),
            windowObject = webView.windowScriptObject(),
            delegate = new MochaJSDelegate();

        delegate.setHandlerForSelector("webView:didFinishLoadForFrame:", function (webView, webFrame) {


            // windowObject.evaluateWebScript("vm.artboards=" + count.artboards);
            // windowObject.evaluateWebScript("vm.allArtboards=" + count.allArtboards);
            // windowObject.evaluateWebScript("vm.allSlice=" + count.allSlice);


            var envdata = {
                env: new String(config.env).toString()
            }
            windowObject.evaluateWebScript("vm.setUrl(" + JSON.stringify(envdata) + ")")


            var secretUrl = _this.getUserValue('secretUrl');
            if (secretUrl) {
                //设置 私有化 URL
                var secretData = {
                    url: new String(secretUrl).toString()
                }
                windowObject.evaluateWebScript("vm.setURL(" + JSON.stringify(secretData) + ")");
            } else {
                //设置公共 URL
                windowObject.evaluateWebScript("vm.setLanhuURL()")
            }

            //是否引导过
            var guide = _this.getUserValue('guide');
            if (!guide) {
                windowObject.evaluateWebScript("vm.showGuide=true");
                windowObject.evaluateWebScript("vm.showSizeGuide=true");
            }

            var lanhuToken = _this.getUserValue('lanhuToken');
            var select = _this.getUserValue('select');
            if (select) {

                //进入上传页面
                if (select) {
                    var data = {
                        token: new String(lanhuToken).toString(),
                        select: new String(select).toString()
                    };
                    // windowObject.evaluateWebScript("vm.scale=" + scale)
                    windowObject.evaluateWebScript("vm.goUpload(" + JSON.stringify(data) + ")");
                };

                try {
                    var sizeText = _this.getUserValue('sizeText'),
                        exportSVG = _this.getUserValue('exportSVG'),
                        sliceScale = _this.getUserValue('sliceScale');

                    var amplification = _this.getUserValue('amplification');
                    // console.log("123",amplification)
                    if (sizeText) {
                        if (amplification != undefined) {
                            var sizeData = {
                                amplification: new String(amplification).toString(),
                                sizeText: new String(sizeText).toString(),
                                exportSVG: new String(exportSVG).toString(),
                                sliceScale: new String(sliceScale).toString()
                            }
                        } else {
                            var sizeData = {
                                sizeText: new String(sizeText).toString(),
                                exportSVG: new String(exportSVG).toString(),
                                sliceScale: new String(sliceScale).toString()
                            }
                        }

                        windowObject.evaluateWebScript("vm.setSize(" + JSON.stringify(sizeData) + ")");
                    }
                } catch (e) {
                    log("setSize" + e);
                    return true
                }

                //选择全部还是选中的Artboard
                if (isAll) {
                    windowObject.evaluateWebScript("vm.uploadType='all'");
                } else {
                    windowObject.evaluateWebScript("vm.uploadType='selected'");
                }
            } else {

                //进入团队选择
                //设置初始化需要的数据
                var baseData = {
                    token: new String(lanhuToken).toString(),
                };
                // windowObject.evaluateWebScript("vm.scale=" + scale)
                windowObject.evaluateWebScript("vm.setDate(" + JSON.stringify(baseData) + ")");
                windowObject.evaluateWebScript("vm.status.team=true");
            };

            //获取文件路径
            try {
                var filePath = context.document.fileURL().path()
                var filedata = {
                    path: new String(filePath).toString()
                }
                windowObject.evaluateWebScript("vm.setFilePath(" + JSON.stringify(filedata) + ")");
                // log('filePath' + filePath)
            } catch (error) {
                log("setFilePath" + error);
            }

            //windowObject.evaluateWebScript("webViewInit(" + JSON.stringify(settings) + ")");
            windowObject.evaluateWebScript("vm.checkSketchBundleVersion('" + NSBundle.mainBundle().objectForInfoDictionaryKey("CFBundleVersion") + "')");
            windowObject.evaluateWebScript("vm.getNewVersion('" + _this.version + "')");
        });

        delegate.setHandlerForSelector("webView:didChangeLocationWithinPageForFrame:", function (webView, webFrame) {
            var webViewRequest = NSURL.URLWithString(webView.mainFrameURL()).fragment();

            if (webViewRequest == "close") {
                closeWebView()
            } else if (webViewRequest == "login") {
                var webViewData = JSON.parse(decodeURI(windowObject.valueForKey("webViewData")));
                //TODO url
                var lanhuToken = webViewData.token;
                _this.setUserValue('lanhuToken', lanhuToken);

                if (webViewData.url) {
                    //如果存在 URL 就是 私有化部署的
                    _this.setUserValue('secretUrl', webViewData.url);
                    var finaurl = webViewData.url + '/sketch?time=' + Math.random() * 100
                } else {
                    //非私有化部署 请求 lanhuapp
                    var finaurl = rootUrl + '/sketch?time=' + Math.random() * 100
                }
                var request = NSURLRequest.requestWithURL(NSURL.URLWithString(finaurl));
                webView.mainFrame().loadRequest(request);
            } else if (webViewRequest == "gotologin") {
                try {

                    var indexurl = context.plugin.urlForResourceNamed("login/index.html")
                    var request = NSURLRequest.requestWithURL(indexurl);
                    webView.mainFrame().loadRequest(request);

                    //删除本地保存的数据
                    _this.removeUserValue("lanhuToken");
                    _this.removeUserValue("select");
                    _this.removeUserValue("secretUrl");
                } catch (e) {

                    log("gotologin" + e);

                }

            } else if (webViewRequest == "gologin") {
                try {


                    openIndexHTML()
                    _this.removeUserValue("lanhuToken");
                    _this.removeUserValue("select");
                    _this.removeUserValue("secretUrl");
                } catch (error) {

                    log("gologin"+ error);

                }
            } else {

                var webViewData = JSON.parse(decodeURI(windowObject.valueForKey("webViewData")));

                //get result data and execute callback
                callback(webViewPanel, NSApp, webViewRequest, webViewData, windowObject);
                result = true;

            }
        });

        contentView.setWantsLayer(true);
        contentView.layer().setFrame(contentView.frame());
        contentView.layer().setCornerRadius(6);
        contentView.layer().setMasksToBounds(true);
        webView.setBackgroundColor(bgcolor);
        webView.setFrameLoadDelegate_(delegate.getClassInstance());

        var lanhuToken = _this.getUserValue('lanhuToken');
        if (lanhuToken) {
            //已经登陆过 直接打开
            var fffurl = _this.getUserValue('secretUrl');
            if (fffurl) {
                //如果存在私有链接 打开私有
                var fffaaurl = fffurl + '/sketch?time=' + Math.random() * 100
            } else {
                var fffaaurl = rootUrl + '/sketch?time=' + Math.random() * 100
            }
            var uu = NSURLRequest.requestWithURL(NSURL.URLWithString(fffaaurl));
            webView.mainFrame().loadRequest(uu);
        } else {
            //未登录 打开登录页
            openIndexHTML()
        }
        // webView.setMainFrameURL_(url);

        contentView.addSubview(webView);

        var closeButton = webViewPanel.standardWindowButton(NSWindowCloseButton);
        closeButton.setCOSJSTargetFunction(function (sender) {
            closeWebView()
        });
        closeButton.setAction("callAction:");

        webViewPanel.becomeKeyWindow();
        webViewPanel.setLevel(NSFloatingWindowLevel);
        webViewPanel.center();
        webViewPanel.makeKeyAndOrderFront(nil);
        this.threadDictionary[identifier] = webViewPanel;

        function test() {

        }

        function openIndexHTML() {
            //打开
            try {
                var indexurl = context.plugin.urlForResourceNamed("login/index.html")
                var request = NSURLRequest.requestWithURL(indexurl);
                webView.mainFrame().loadRequest(request);
            } catch (error) {
                log("openIndexHTML"+ error);
            }
        }

        function closeWebView() {

            _this.shouldClose = true;
            coscript.setShouldKeepAround(false);
            _this.threadDictionary.removeObjectForKey(identifier)
            webViewPanel.close();
        }
        return result;
    }
}