/*
 * @Author: smallStone
 * @Date: 2017-07-24 18:34:25
 * @Last Modified by: smallStone
 * @Last Modified time: 2018-07-31 11:22:48
 */
@import 'MochaJSDelegate.js';
@import 'config.js'
@import 'Lanhu.framework/API/lanhu.js'
@import 'Lanhu.framework/Lanhu.js'

var projectId = '',
	selectedObj = {},
	rootUrl;

function all(context) {
	lanhu.init(context)
	onRun(context, true);
}

function select(context) {
	lanhu.init(context)
	onRun(context, false)
}

function clean(context) {
	var text = '请注意,登录信息清除后将无法恢复.';
	var	title = '清除登录信息';
	var alert = NSAlert.alloc().init();
	var plugin = context.plugin;
	var imageFilePath = plugin.urlForResourceNamed("logo.png");
	var imageData = NSData.dataWithContentsOfURL(imageFilePath);
	var image = NSImage.alloc().initWithData(imageData);
	alert.setIcon(image);
	alert.setInformativeText(text);
	alert.setMessageText(title);
	alert.addButtonWithTitle("清除");
	alert.addButtonWithTitle("取消");
	var code = alert.runModal();
	if (code == 1000) {
		NSUserDefaults.standardUserDefaults().removeObjectForKey("lanhuToken");
		NSUserDefaults.standardUserDefaults().removeObjectForKey("select");
		NSUserDefaults.standardUserDefaults().removeObjectForKey("secretUrl");
		NSUserDefaults.standardUserDefaults().removeObjectForKey("proId");
		// NSUserDefaults.standardUserDefaults().removeObjectForKey("guide");
		NSUserDefaults.standardUserDefaults().removeObjectForKey("sizeText");
		NSUserDefaults.standardUserDefaults().removeObjectForKey("sliceScale");
		NSUserDefaults.standardUserDefaults().removeObjectForKey("exportSVG");
		// NSUserDefaults.standardUserDefaults().removeObjectForKey("noversion");
	}
}

var onRun = function (context, isAll) {

	var issaved = lanhu.saveDocument(context)
	if (!issaved) {
		return false
	}

	//获取token
	var proId = lanhu.getUserValue('proId');
	projectId = proId

	lanhu.render(context, isAll, function (webViewPanel, NSApp, webViewRequest, webViewData, windowObject) {
		var document = context.document,
			ArtboardScale;

		var fffurl = lanhu.getUserValue('secretUrl');
		if (fffurl) {
			//如果存在私有链接 打开私有
			rootUrl = fffurl
		}

		// console.log("webViewRequest",webViewRequest)
		// console.log("webViewRequest",webViewData)

		if (webViewRequest == "amplification1111") {
			var amplification = webViewData.amplification;
			lanhu.setUserValue('amplification', amplification);
		}

		if (webViewRequest == "login") {
			var lanhuToken = webViewData.token;
			if (webViewData.url) {
				//如果存在 URL 就是 私有化部署的
				lanhu.setUserValue('secretUrl', webViewData.url);
			}
			lanhu.setUserValue('lanhuToken', lanhuToken);
		};

		if (webViewRequest == "selected") {
			var select = JSON.stringify(webViewData);
			var proId = webViewData.selected.proId;
			projectId = proId;
			lanhu.setUserValue('select', select);
			lanhu.setUserValue('proId', proId);

		};

		if (webViewRequest == "hideguide") {
			lanhu.setUserValue('guide', true);
		};

		if (webViewRequest == "logout") {

			lanhu.removeUserValue("lanhuToken");
			lanhu.removeUserValue("select");
		};

		/*
			@ 此处为菜单选项入口
		*/

		if (webViewRequest == "all" || webViewRequest == "pages") {
			if (document.currentPage().artboards().length == 0) {
				lanhu.alert('当前pages似乎没有artboard');
				return false;
			};

			var sliceScale = webViewData.sliceScale,
				ArtboardScale = webViewData.ArtboardScale,
				exportSVG = webViewData.exportSVG,
				sizeText = webViewData.sizeText;

			var amplification = webViewData.amplification;

			if (amplification != undefined) {
				lanhu.setUserValue('amplification', amplification);
			}

			lanhu.setUserValue('sizeText', sizeText);
			lanhu.setUserValue('sliceScale', sliceScale);
			lanhu.setUserValue('exportSVG', exportSVG);
			lanhu.initlayer(context, document, sliceScale, ArtboardScale, exportSVG, amplification, windowObject, webViewRequest, rootUrl);
		};

		if (webViewRequest == "register") {
			var webUrl = rootUrl + 'web/#!/user/register';
			lanhu.openUrl(webUrl)
		};

		if (webViewRequest == "openNewURL") {
			lanhu.openUrl(webViewData.url)
		};

		if (webViewRequest == "alertUpdate") {
			lanhu.openUrl(webViewData.url)
		};

		if (webViewRequest == "web1") {

			var webUrl = rootUrl + 'web';
			lanhu.openUrl(webUrl)
		};

		if (webViewRequest == "storeData") {
			NSUserDefaults.standardUserDefaults().setObject_forKey(webViewData.value, webViewData.key)
        	NSUserDefaults.standardUserDefaults().synchronize()
		}

		if (webViewRequest == "readData") {
			var value = NSUserDefaults.standardUserDefaults().objectForKey(webViewData.key);
			// if (value) {
			// 	windowObject.evaluateWebScript("vm." + webViewData.key + "='" + value +"'");
			// } else {
			// 	windowObject.evaluateWebScript("vm." + webViewData.key + "='nsnull'");
			// }
			if (value) {
				windowObject.evaluateWebScript("vm.anyKey='" + JSON.stringify(value) +"'");
			} else {
				windowObject.evaluateWebScript("vm.anyKey='nsnull'");
			}
		}

		if (webViewRequest == "deleteData") {
			NSUserDefaults.standardUserDefaults().removeObjectForKey(webViewData.key);
		}


		if (webViewRequest == "web") {
			var webUrl;
			if (rootUrl == "http://localhost:8890/") {
				webUrl = 'https://dev.lanhuapp.com/web/#!/item/board?pid=' + projectId + "&see=all";
			} else {
				webUrl = rootUrl + '/web/#!/item/board?pid=' + projectId + "&see=all";
			}

			lanhu.openUrl(webUrl)
		};

		if (webViewRequest == "help") {

			var url = "http://help.lanhuapp.com/hc/kb/article/1068673"
			lanhu.openUrl(url)
		};

		if (webViewRequest == "url" || webViewRequest == "update" || webViewRequest == "helpicon") {
			var webUrl = webViewData.url;
			lanhu.openUrl(webUrl)
		};


		if (webViewRequest == 'newversion') {
			//新版本
			var cancelalert = NSAlert.alloc().init();
			var cancelplugin = context.plugin;
			var cancelimageFilePath = cancelplugin.urlForResourceNamed("logo.png");
			var cancelimageData = NSData.dataWithContentsOfURL(cancelimageFilePath);
			var cancelimage = NSImage.alloc().initWithData(cancelimageData);
			cancelalert.setIcon(cancelimage);
			cancelalert.setMessageText('哇~发现超腻害的新版本，要不要现在体验下？');
			cancelalert.addButtonWithTitle("下载新版");
			cancelalert.addButtonWithTitle("关闭");
			var code = cancelalert.runModal();

			if (code == 1000) {
				lanhu.openUrl(webViewData.url)
			};
		};

		if (webViewRequest == "report") {



			if (webViewData.length > 0) {
				var errstr = webViewData.join("\n");
				NSPasteboard.generalPasteboard().declareTypes(NSArray.arrayWithObject(NSStringPboardType).owner(self))
				NSPasteboard.generalPasteboard().setString_forType(errstr, NSStringPboardType)
				lanhu.alert('cmd+v即可粘贴', '复制成功');
			} else {
				lanhu.alert('好像没有错误日志哦~', '');
			}
		}
	});
};